﻿@model Generations.MVC.Models.MissionaryTreeModel

@{
    ViewBag.Title = "Tree";
}

@section JavaScript
{
    <script type="text/javascript" src='https://www.google.com/jsapi'></script>
    <script type="text/javascript">
        // Load the specific chart package for this page
        google.load('visualization', '1', { packages: ['orgchart'] });
        google.setOnLoadCallback(drawChart);
        function drawChart() {
            var data = new google.visualization.DataTable();
            data.addColumn('string', 'Name');
            data.addColumn('string', 'Manager');
            data.addColumn('string', 'ToolTip');

            // Serialize Model for JS
            var model = @Html.Raw(Json.Encode(Model));
            
            // Add Root
            var rowIndex = data.addRow();
            var addAction = '<a href=\'../../Missionary/Create/'+model.Missionary.Id.toString()+'\'>[add]</a>';
            var editAction = '<a href=\'../../Missionary/Edit/'+model.Missionary.Id.toString()+'\'>[edit]</a>';
            data.setCell(rowIndex, 0, model.Missionary.Id.toString(), model.Missionary.Name + '<br />' + addAction + editAction);
            data.setCell(rowIndex, 2, model.Missionary.StateName);

            // Add Children
            recurseChildren(model.Missionary, data);
            
            var chart = new google.visualization.OrgChart(document.getElementById('chart_div'));
            chart.draw(data, { allowHtml: true });
        }

        function recurseChildren(missionary, data)
        {            
            for (var i = 0, count = missionary.Children.length;i < count;i++) {
                var rowIndex = data.addRow();

                addAction = '<a href=\'../../Missionary/Create/'+missionary.Children[i].Id.toString()+'\'>[add]</a>';
                editAction = '<a href=\'../../Missionary/Edit/'+missionary.Children[i].Id.toString()+'\'>[edit]</a>';
                
                data.setCell(rowIndex, 0, missionary.Children[i].Id.toString(), missionary.Children[i].Name + '<br />' + addAction + editAction);
                data.setCell(rowIndex, 1, missionary.Id.toString());
                data.setCell(rowIndex, 2, missionary.Children[i].Id.toString());

                recurseChildren(missionary.Children[i], data);
            }
        }
    </script>
}

@if (Model.Missionary.ParentMissionaryId != null) { 
    <a href="../../Missionary/Tree/@Model.Missionary.ParentMissionaryId">Go To Parent</a>
}

<div id="chart_div"></div>
